/*
 * Number5State.java
 *
 * Created on 26. březen 2006, 19:05
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.number5;

import cz.muni.fi.fibot.Robot.Direction;
import cz.muni.fi.fibot.Strategy.BotAction;


/**
 *
 * @author Gaul
 */
public class Number5State {
    int positionX;
    int positionY;
    
    int energy;
    protected Direction direction;
    protected int points;
    
    BotAction action;
    
    public Number5State(int positionX, int positionY, int energy, Direction direction, int points){
        this.positionX = positionX;
        this.positionY = positionY;
        this.energy = energy;
        this.direction = direction;
        this.points = points;
    }
    
    public Number5State clone(){
        return new Number5State(positionX, positionY, energy, direction, points);
    }
    
    public void simulate(BotAction a, int restEnergy, int maxEnergy, boolean getsHit){
        
        int directionX, directionY;
        directionX = directionY = 0;
        
        switch(direction){
            case LEFT: directionX = -1; break;
            case RIGHT: directionX = 1; break;
            case UP: directionY = -1; break;
            case DOWN: directionY = 1; break;
        }
        int index = 0;
        for(Direction d : Direction.values()){
            if(d == direction) break;
            else index++;
        }
        
        energy--;
        
        if(getsHit) energy -= (int)Math.floor(energy/2);
        
        switch(a){
            case STEP: positionX += directionX;
                       positionY += directionY;
                       break;
            case LEFT: direction = Direction.values()[(index + 3) % 4];
                       break;
            case RIGHT: direction = Direction.values()[(index + 1) % 4];
                        break;
            case REST: energy += restEnergy;
                       break;
            case RECHARGE: energy = maxEnergy;
                           break;
        }
    }
}