package cz.muni.fi.fibot.pepa ;

import cz.muni.fi.fibot.Robot ;
import cz.muni.fi.fibot.Strategy ;
import cz.muni.fi.fibot.World ;

public class PePa implements Strategy {

private World world ;
private Robot robot ;
private boolean rotace ;
private int prev_X  ;
private int prev_Y  ;

public PePa() {
        rotace = false ;
        int prev_X = -1 ;
        int prev_Y = -1 ;
}

public void setWorld(World w) {
        this.world = w ;
}

public void setRobot(Robot r) {
        this.robot = r ;
}

public void initialize() {
}
public Strategy.BotAction decide() {
       if (robot.getEnergy() < 3) {
                return BotAction.REST ;
       }
       if (world.containsTreasure(robot.getPositionX() , robot.getPositionY()))        {        return BotAction.TAKE ; 
       }
       if (world.containsBattery(robot.getPositionX() , robot.getPositionY()) &&            (robot.getEnergy() < (world.getMaxRobotEnergy() / 2) )) { 
                return BotAction.RECHARGE ; 
       }
       if (robot.getPositionX() == prev_X && 
           robot.getPositionY() == prev_Y && rotace == false) {
                rotace = true ;
                return BotAction.LEFT ;
       } else {
                rotace = false ;
                prev_X = robot.getPositionX() ;
                prev_Y = robot.getPositionY() ;
                return BotAction.STEP ;
       }
   }
} 
