/*
 * GeneralStrategy.java
 *
 * Created on 3. bezen 2006, 9:06
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.pikachu;

import cz.muni.fi.fibot.Robot;
import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.Strategy.BotAction;
import cz.muni.fi.fibot.World;

/**
 * First general Pikachu stratechy for testing
 *
 * @author xnovak8
 */
public class GeneralStrategy implements Strategy {

    /** actual World */
    private World world;
    
    /** the robot to decide for */
    private Robot robot;
    
    /** Creates a new instance of GeneralStrategy */
    public GeneralStrategy() {
    }
    
    public void setWorld(World world) {
        this.world = world;
    }
    
    public void setRobot(Robot robot) {
        this.robot = robot;
    }
    
    public void initialize() {
        
    }
    
    public Strategy.BotAction decide() {
        
        return decideByStupidBrutalForce();
        //return BotAction.SHOOT;
    }    
    
    /** generates the state space and goes through it using brutal force.
     * The depth is limited by
     */
    private Strategy.BotAction decideByStupidBrutalForce() {
        
        AvailabilityMap map = new AvailabilityMap(world);
        map.fillAvailabilityMap(robot);
        System.out.println(map.toString());
        return BotAction.STEP;
    }
    
}
