/*
 * Position.java
 *
 * Created on 16. bezen 2006, 0:27
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.pikachu;

import cz.muni.fi.fibot.Robot.Direction;

/**
 *  this small class encapsulates the position (X, Y) and (optionally) the direction
 * 
 * @author Administrator
 */
public class Position implements Cloneable {
    public int x;
    public int y;
    public Direction direction;

    public Position(int x, int y) {
        this(x, y, null);
    }
    
    public Position(int x, int y, Direction direction) {
        this.x = x;
        this.y = y;
        this.direction = direction;
    }
    
    public boolean equals(Object obj) {
        if (! (obj instanceof Position))
            return false;
        return (((Position) obj).x == x && ((Position) obj).y == y 
                && ((((Position) obj).direction == direction) || ((Position) obj).direction == null || 
                direction == null));
    }
    
    protected Position clone() {
        try {
            return (Position) super.clone();
        } catch (CloneNotSupportedException ignore) { 
            return this;
        }
    }
    
    public String toString() {
        return ("Position: "+x+", "+y+", direction: "+((direction==null)?"null":direction));
    }
}

