package cz.muni.fi.fibot.vtipnynazev;

public class Coord {
	public static final int LEFT = 0;
	public static final int UP = 1;
	public static final int RIGHT = 2;
	public static final int DOWN = 3;
	public static int DIMX;
	public static int DIMY;
	public static Coord[] dir;
	
	public static void initDir(int w, int h) {
		dir = new Coord[4];
		dir[LEFT] = new Coord(-1, 0); 
		dir[UP] = new Coord(0, -1); 
		dir[RIGHT] = new Coord(1, 0); 
		dir[DOWN] = new Coord(0, 1); 
		DIMX = w;
		DIMY = h;
	}
	
	public static int getDir(Coord coord) {
		if (coord.m_x < 0)
			return LEFT;
		if (coord.m_x > 0)
			return RIGHT;
		if (coord.m_y < 0)
			return UP;
		return DOWN;
	}
	
	public boolean inside() {
		return (m_x >= 0) && (m_x < DIMX) && (m_y >= 0) && (m_y < DIMY);
	}
	
	public int m_x;
	public int m_y;
	
	public Coord() {}
	
	public Coord(int x, int y) {
		m_x = x;
		m_y = y;
	}
	
	public String toString() {
		return "[" + m_x + "," + m_y + "]";
	}
}
