package cz.muni.fi.fibot.vtipnynazev.purestrat;

import cz.muni.fi.fibot.Strategy;
import cz.muni.fi.fibot.vtipnynazev.MyWorld;

public class SRecharge implements IPureStrat {
	public static final int ENERGYLIMIT = 3;
	
	public double getExpectedProfit(MyWorld world) {
		return 0.0;
	}
	
	public SRecharge() {}
	
	public boolean isInterrupted(MyWorld world) {
		return world.m_me.energy > ENERGYLIMIT; 
	}
	
	public Strategy.BotAction getNextAction(MyWorld world) {
		if (world.containsBattery(world.m_me.positionX, world.m_me.positionY))
			return Strategy.BotAction.RECHARGE;
		else
			return Strategy.BotAction.REST;
	}	
	
	public IPureStrat clone() {
		return new SRecharge(); 
	}
}
