/*
 * VirtualOpponent.java
 *
 * Created on 9. duben 2006, 11:03
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.chobot;

import cz.muni.fi.fibot.Robot;
import cz.muni.fi.fibot.Robot.Direction;
import cz.muni.fi.fibot.World;

/**
 *
 * @author Andy1
 */
public class VirtualOpponent extends Position implements Cloneable{
    
    private Robot robot;
    private int energy;
    private World world;
    //private PathFinder pathfinder;
    
    /** Creates a new instance of VirtualOpponent */
    public VirtualOpponent(ChoBot strategy, Robot robot) {
        super(robot.getPositionX(), robot.getPositionY(), robot.getDirection()); 
        this.robot=robot;   
        this.energy=robot.getEnergy();
        this.world = world;
        //this.pathfinder = new PathFinder(strategy);
        //this.pathfinder.runWatcher();
    }
    
   // public PathFinder getPathFinder(){
   //     return pathfinder;
   // }
    
    public Robot getRobot(){
        return robot;
    }
    
    public Robot.Direction getDirection() {
        Direction retValue;
        super.setDirection(this.robot.getDirection());
        retValue = super.getDirection();
        return retValue;
    }

    public int getX() {
        int retValue;
        super.setX(this.robot.getPositionX());
        retValue = super.getX();
        return retValue;
    }
        
    public int getY() {
        int retValue;
        super.setY(this.robot.getPositionY());
        retValue = super.getY();
        return retValue;
    }

    public int getEnergy(){
        return energy;
    }
    
    public void resetEnergy(){
        energy=robot.getEnergy();
    }
    
    public void setEnergy(int e){
        energy = e;
    }
    
    public void setRobot(Robot r){
        robot = r;
    }
    
    public String toString(){
        return super.toString();
    }
    
    public Object clone(){
        VirtualOpponent o = (VirtualOpponent) super.clone();
        o.setRobot(this.getRobot());
        o.setEnergy(this.getEnergy());
        return o;
    }
}
