/*
 * Point.java
 *
 * Created on 19. duben 2006, 20:46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package cz.muni.fi.fibot.hamsterinside;

import cz.muni.fi.fibot.Robot;

/**
 * Bod
 * @author bobo
 */
public class Point {
    public int x, y;
    public Point(int nX, int nY) {
        x = nX; y = nY;
    }
    public Point(Point value) {
        x = value.x; y = value.y;
    }
    public Point(Robot value) {
        x = value.getPositionX();
        y = value.getPositionY();
    }
    public void setPos(int nX, int nY) {
        x = nX; y = nY;
    }
    public void setPos(Point nPos) {
        x = nPos.x; y = nPos.y;
    }
    public boolean equals(Object value) {
        if (value.getClass() == this.getClass()) {
            Point p = (Point) value;
            if ((p.x == this.x) && (p.y == this.y)) {
                return true;
            }
        }
        return false;
    }
}
