package cz.muni.fi.fibot.number5;

import cz.muni.fi.fibot.Robot.Direction;

public class Number5Prediction {
	
	/**
	 * pravdepodobnost naplneni odhadu
	 * - rozsah 0-100
	 * - kdyz je nastavena 0, ostatni udaje nemusi byt nastavene 
	 */
	protected int probability;
	
	protected Number5Square position;
	protected Direction direction;
	protected int energy;
	
	protected static Number5Prediction DONT_KNOW = new Number5Prediction(0, null, Direction.LEFT, 0);
	
	public Number5Prediction(int probability, Number5Square position, Direction direction, int energy){
		this.probability = probability;
		this.position = position;
		this.direction = direction;
		this.energy = energy;
	}
        
        public String toString(){
            if(this == DONT_KNOW) return "nevim";
            else return "pravdepodobnost: " + probability + "%, pozice: " + position + ", smer: " + direction + ", energie: " + energy;
        }
}
